import { type Options, type PostgresType } from 'postgres';
import { type MigrationMetadata, type EmigrateStorage, type LoaderPlugin, type Storage, type GenerateMigrationFunction, type GeneratorPlugin } from '@emigrate/types';
type ConnectionOptions = Options<Record<string, PostgresType>>;
export type PostgresStorageOptions = {
    table?: string;
    /**
     * @see https://github.com/porsager/postgres#connection
     */
    connection: ConnectionOptions | string;
};
export type PostgresLoaderOptions = {
    /**
     * @see https://github.com/porsager/postgres#connection
     */
    connection: ConnectionOptions | string;
};
export declare const createPostgresStorage: ({ table, connection, }: PostgresStorageOptions) => EmigrateStorage;
export declare const initializeStorage: () => Promise<Storage>;
export declare const createPostgresLoader: ({ connection }: PostgresLoaderOptions) => LoaderPlugin;
export declare const loadableExtensions: string[], loadMigration: (migration: MigrationMetadata) => import("@emigrate/types").Awaitable<import("@emigrate/types").MigrationFunction>;
export declare const generateMigration: GenerateMigrationFunction;
declare const defaultExport: EmigrateStorage & LoaderPlugin & GeneratorPlugin;
export default defaultExport;
//# sourceMappingURL=index.d.ts.map